// SfvChk.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <TCHAR.H>
#include <direct.h>
#include <time.h>

#include "Locking.h"
#include "SimiyIni.h"
#include "SimiyUtil.h"
#include "SimiySfvChk.h"

// for command-line argument
TCHAR _ARGV[10][_MAX_PATH+1];
int _ARGC = 0;

//--------------------------------------------------------------------
//	Parsing command-line, store arguments in _ARGC, _ARGV
//--------------------------------------------------------------------
void ParseCmdLine( LPCTSTR szCmdLine )
{
	bool fInQuote;
	bool bStartArg;
	
	int chIdx = 0;

	fInQuote = false;
	bStartArg = false;
	
	for(; *szCmdLine != _TEXT('\0'); szCmdLine++ )
	{
		switch (*szCmdLine) {
		case _TEXT('"'):
			fInQuote = !fInQuote;
			if(fInQuote)
			{
				_ARGC ++;
				bStartArg = true;	// New Argument
				chIdx = 0;
			}
			else
			{
				bStartArg = false;	// " end
				_ARGV[_ARGC - 1][chIdx] = _TEXT('\0');
			}
			break;
		case _TEXT(' '): case _TEXT('\t'):
			if (fInQuote) {
				_ARGV[_ARGC - 1][chIdx++] = *szCmdLine;
			}
			else
			{
				bStartArg = false;	// New Space = End a argument
				_ARGV[_ARGC - 1][chIdx] = _TEXT('\0');
			}
			break;
		default:
			if( ! bStartArg )
			{
				_ARGC ++;
				bStartArg = true;	// New Argument
				chIdx = 0;
			}
			_ARGV[_ARGC - 1][chIdx++] = *szCmdLine;
			break;
        }
    }
	if( _ARGC > 0 )	// Last argument - null terminating
	{
		_ARGV[_ARGC - 1][chIdx] = _TEXT('\0');
	}
} 

//--------------------------------------------------------------------
//	Main Job Branch
//--------------------------------------------------------------------
void sfv_check( LPCTSTR cmd )
{
	if( ! _tcscmp(cmd, "fileuploaded") )
	{
		if( _ARGC < 7 ) return;
		file_uploaded( _ARGV[3], _ARGV[4], _ARGV[5], _ARGV[6] );
	}
	else if( ! _tcscmp(cmd, "filedeleted") )
	{
		if( _ARGC < 3 ) return;
		file_deleted(  );
	}
	else if( ! _tcscmp(cmd, "sfvsuccess") )
	{
		if( _ARGC < 9 ) return;
		sfv_success( _ARGV[3], _ARGV[4], _ARGV[5], _ARGV[6], _ARGV[7], _ARGV[8] );
	}
	else if( ! _tcscmp(cmd, "sfvuploaded") )
	{
		if(_ARGC < 5) return;
		sfv_uploaded( _ARGV[3], _ARGV[4] );
	}
	else if( ! _tcscmp(cmd, "sfvfailed") )
	{
		if( _ARGC < 7 ) return;
		sfv_failed( _ARGV[3], _ARGV[4], _ARGV[5], _ARGV[6] );
	}
	else if( ! _tcscmp(cmd, "sfvcomplete") )
	{
		if( _ARGC < 3 ) return;
		sfv_complete(  );
	}
}

struct _SFVCHK	SFVCHK;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// Parsing command-line
	ParseCmdLine( GetCommandLine() );

	/*
	if(_ARGC == 2) {
		clock_t start = clock();
		unsigned long crc = getFileCRC32( _ARGV[1] );
		clock_t end = clock();
		TCHAR buf[512];
		_stprintf(buf, "%s's crc32 = %X (%f secs)",  _ARGV[1] , crc, (double)(end-start) / CLOCKS_PER_SEC);
		MessageBox(NULL, buf, "crc", 0);
		return 0;
	}
	*/
	if(_ARGC < 3) return false;	// Wrong Argument Count

	TCHAR filePath[_MAX_PATH + 1];	// file full path

	GetDirName( _ARGV[2], SFVCHK.UP_DIR );	// Get Upload Directory

	if( ! MyEnterCriticalSection( SFVCHK.UP_DIR ) )	// Wait Locking & Lock
	{
		return 0;	// failed locking, exit
	}

	GetDirName( _ARGV[0], filePath);	// SfvChk Directory
	_tcscat(filePath, "\\SfvChk.ini");	// SfvChk.ini
	SimiyIni.ReadIni( filePath );		// obtain ini's key value


	GetFileName( _ARGV[2], SFVCHK.UP_FILE );
	_stprintf( SFVCHK.LOG_PATH, "%s%s", SFVCHK.UP_DIR,
		SimiyIni.GetValueString("GENERAL", "LOGFILE", ".upChk.log") );	// append log filename

	// go upload directory
	_tchdir( SFVCHK.UP_DIR );

	_tcslwr(  _ARGV[1] );
	sfv_check( _ARGV[1] );	// Main Job Branch

	MyEndCriticalSection( );		// Unlock

	return 0;
}