#ifndef __SIMIY_INI_H__

#define __SIMIY_INI_H__

#include <stdio.h>
#include <ctype.h>
#include <tchar.h>
#include <stdlib.h>
#include "LinkedList.h"

#define SFVCHK_LOGFILE	_TEXT("SfvChk.log")

struct IniNode
{
	TCHAR Section[32];	// length limits = 31
	TCHAR Key[32];		// length limits = 31
	TCHAR Value[256];	// length limits = 256
};

class CSimiyIni
{
protected:
	CLinkedList *m_Ini;
	TCHAR		m_IniPath[_MAX_PATH];
public:
	CSimiyIni();
	~CSimiyIni();
	void	InitIni();
	bool	ReadIni(LPCTSTR filename);
	int		GetValueInt(LPCTSTR section, LPCTSTR key, int Default);
	LPCTSTR	GetValueString(LPCTSTR section, LPCTSTR key, LPCTSTR Default);

	bool	IsIncludeNoCntFExt(LPCTSTR filename);

	bool SfvChkLogAppend(LPCTSTR format, ... );
};

extern CSimiyIni	SimiyIni;

#endif